/*** SSI_DEM3.C ***/

#define float long double

#include "graficos.c"
#include "ssi.c"

float f1(float u, float v) { return v; }
float f2(float u, float v) { return u*u/10 + v*v/10 - 5; }
float f3(float u, float v) { return u; }

float g1(float u, float v) { return u*cos(v); }
float g2(float u, float v) { return u*sin(v); }
float g3(float u, float v) { return v; }

void main(void) {

  int n;
  float x0, y0, x1, y1;

  /*
  signal(SIGFPE, Erro);
  signal(SIGABRT, Erro);
  signal(SIGTERM, Erro);
  signal(SIGINT, Erro);
  signal(SIGSEGV, Erro);
  */
  arq = fopen("MENS.ERR", "wt");

  TAM = 27; inc = 0.05;
  o1 = 3, o2 = 1, o3 = 1.2;
  IniciaModoGrafico();
  A = getmaxx()/2; B = getmaxy()/2;
  DeterminaPlanoDeProjecao();
  setcolor(BLUE);
  DesenhaSuperficie2(f1, f2, f3, -8, 8, -8, 8);
  setcolor(RED);
  DesenhaSuperficie2(g1, g2, g3, -8, 8, -8, 8);
  setcolor(YELLOW);

  x0 = y0 = x1 = y1 = -1;
  n = SSI(f1, f2, f3, g1, g2, g3, x0, y0, -8, 8, -8, 8, x1, y1, -8, 8, -8, 8);
  fprintf(arq, "\n\nSSI = %d  (a, b) (c, d) = (%5.2Lf, %5.2Lf) (%5.2Lf, %5.2Lf)",
			       n, x0, y0, x1, y1);
  if (n < 0) MensagemErro(n);
  n = SSI2(f1, f2, f3, g1, g2, g3, x0, y0, -8, 8, -8, 8, x1, y1, -8, 8, -8, 8);
  fprintf(arq, "\n\nSSI = %d  (a, b) (c, d) = (%5.2Lf, %5.2Lf) (%5.2Lf, %5.2Lf)",
			       n, x0, y0, x1, y1);
  if (n < 0) MensagemErro(n);

  x0 = -1; y0 = 3; x1 = 1; y1 = -3;
  n = SSI(f1, f2, f3, g1, g2, g3, x0, y0, -8, 8, -8, 8, x1, y1, -8, 8, -8, 8);
  fprintf(arq, "\n\nSSI = %d  (a, b) (c, d) = (%5.2Lf, %5.2Lf) (%5.2Lf, %5.2Lf)",
			       n, x0, y0, x1, y1);
  if (n < 0) MensagemErro(n);
  n = SSI2(f1, f2, f3, g1, g2, g3, x0, y0, -8, 8, -8, 8, x1, y1, -8, 8, -8, 8);
  fprintf(arq, "\n\nSSI = %d  (a, b) (c, d) = (%5.2Lf, %5.2Lf) (%5.2Lf, %5.2Lf)",
			       n, x0, y0, x1, y1);
  if (n < 0) MensagemErro(n);

  x0 = y0 = x1 = y1 = 1;
  n = SSI(f1, f2, f3, g1, g2, g3, x0, y0, -8, 8, -8, 8, x1, y1, -8, 8, -8, 8);
  fprintf(arq, "\n\nSSI = %d  (a, b) (c, d) = (%5.2Lf, %5.2Lf) (%5.2Lf, %5.2Lf)",
			       n, x0, y0, x1, y1);
  if (n < 0) MensagemErro(n);
  n = SSI2(f1, f2, f3, g1, g2, g3, x0, y0, -8, 8, -8, 8, x1, y1, -8, 8, -8, 8);
  fprintf(arq, "\n\nSSI = %d  (a, b) (c, d) = (%5.2Lf, %5.2Lf) (%5.2Lf, %5.2Lf)",
			       n, x0, y0, x1, y1);
  if (n < 0) MensagemErro(n);

  x0 = -1; y0 = 0; x1 = 0; y1 = -1;
  n = SSI(f1, f2, f3, g1, g2, g3, x0, y0, -8, 8, -8, 8, x1, y1, -8, 8, -8, 8);
  fprintf(arq, "\n\nSSI = %d  (a, b) (c, d) = (%5.2Lf, %5.2Lf) (%5.2Lf, %5.2Lf)",
			       n, x0, y0, x1, y1);
  if (n < 0) MensagemErro(n);
  n = SSI2(f1, f2, f3, g1, g2, g3, x0, y0, -8, 8, -8, 8, x1, y1, -8, 8, -8, 8);
  fprintf(arq, "\n\nSSI = %d  (a, b) (c, d) = (%5.2Lf, %5.2Lf) (%5.2Lf, %5.2Lf)",
			       n, x0, y0, x1, y1);
  if (n < 0) MensagemErro(n);

  getch();
  closegraph();
  fclose(arq);
}

/*** FIM DE SSI_DEM3.C ***/
